/*  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.

 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;

public class Main {
	public static void main(String[] args) throws IOException {
	    try {
	        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	    }
	    catch (Exception e) {}
		Object[] options = new Object[] {
				"Expand", "Create", "Cancel"
		};
		int option = JOptionPane.showOptionDialog(null, "What would you like to do?", "WAD Archive Manipulator", 
				JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, 
				null, options, null);
		if(option == JOptionPane.CLOSED_OPTION || option == 2) {
			return;
		}
		
		if(option == 0) {
			final String default_folder = "C:/Program Files/Steam/steamapps/common/magic the gathering - duels of the planeswalkers/";
			int returnVal;
			JFileChooser inputFC = new JFileChooser(default_folder);
			inputFC.setDialogTitle("Select Source File");
			inputFC.setFileSelectionMode(JFileChooser.FILES_ONLY);
            returnVal = inputFC.showOpenDialog(null);
            if(returnVal != JFileChooser.APPROVE_OPTION) return;
            JFileChooser outputFC = new JFileChooser();
            outputFC.setDialogTitle("Select Destination Folder");
            outputFC.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            returnVal = outputFC.showOpenDialog(null);
            if(returnVal != JFileChooser.APPROVE_OPTION) return;
            File infile = inputFC.getSelectedFile();
			File outfile = outputFC.getSelectedFile();
			RandomAccessFile r = new RandomAccessFile(infile, "r");
			ProgressDisplay display = new ProgressDisplay();
			WadReader.read(r, outfile, display);
		}
		if(option == 1) {
			int returnVal;
			JFileChooser inputFC = new JFileChooser();
			inputFC.setDialogTitle("Select Source Folder");
			inputFC.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            returnVal = inputFC.showOpenDialog(null);
            if(returnVal != JFileChooser.APPROVE_OPTION) return;
            JFileChooser outputFC = new JFileChooser();
            outputFC.setDialogTitle("Select Destination File");
            outputFC.setFileSelectionMode(JFileChooser.FILES_ONLY);
            returnVal = outputFC.showOpenDialog(null);
            if(returnVal != JFileChooser.APPROVE_OPTION) return;
            File infile = inputFC.getSelectedFile();
			File outfile = outputFC.getSelectedFile();
			if(outfile.exists()) outfile.delete();
			RandomAccessFile r = new RandomAccessFile(outfile, "rw");
			ProgressDisplay display = new ProgressDisplay();
			WadMaker.create(infile, r, display);
		}
	}
}
