import java.awt.Component;
import java.awt.Dimension;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;


public class ProgressDisplay extends JFrame {
	JPanel panel;
	JLabel label;
	JProgressBar progress;
	public ProgressDisplay() {
		this.setTitle("Wad Archive Program");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setSize(800, 80);
		panel = new JPanel();
		label = new JLabel();
		label.setAlignmentX(Component.CENTER_ALIGNMENT);
		label.setMaximumSize(new Dimension(800, 40));
		label.setHorizontalTextPosition(JLabel.CENTER);
		progress = new JProgressBar();
		progress.setMaximumSize(new Dimension(400, 40));
		progress.setAlignmentX(Component.CENTER_ALIGNMENT);
		progress.setIndeterminate(true);
		panel.add(label);
		this.getContentPane().add(panel);
		JPanel bottom = new JPanel();
		bottom.setAlignmentX(Component.CENTER_ALIGNMENT);
		panel.add(bottom);
		bottom.add(progress);
		panel.setLayout(new BoxLayout(panel, BoxLayout.PAGE_AXIS));
		this.setVisible(true);
		label.setText("Starting...");
	}
	public void setMaximumProgress(int maximum) {
		progress.setIndeterminate(false);
		progress.setMaximum(maximum);
	}
	public void update(String message, boolean center, int progressUpdate) {
		if(center) label.setMaximumSize(null);
		else label.setMaximumSize(new Dimension(800, 40));
		label.setText(message);
		progress.setValue(progressUpdate);
	}
}
